import { Alert,Button, Form, Input, Select, Radio, Space, Upload, Steps } from 'antd';
import styled from 'styled-components';
import { getDagInfomation, getDataSourceInfo, getTableNameInfo } from '../services'
import { useEffect, useState } from 'react'
import bus from '../../../bus.js'


const StepTwo = styled.div`
  display: flex;
  .StepTwo-content {

    width: 847px; 
    height: 450px; 
    margin-left: 50px; 
    margin-top: 20px; 
    overflow-y: scroll;
    overflow-y: hidden;
    border: 1px solid #C8D3E9;
    .dtsource {
      .ant-select {
        width:80%;
      }
    }
    .ant-row {    
      margin-left: 37px;
      flex-wrap: nowrap;
    }
    .content-item {
      margin-top: 17px;
      margin-left: -14px;
      .ant-form {
        flex-direction: row;
        justify-content: left;
        .ant-form-item {
          margin-bottom: 10px;
        }
      }
      .item-choseList {
        margin-top: -3px;
        margin-left: -75px;
        .ant-select {
          width: 158px;
        }
      }
      .stateIcon {
        display: inline-block;
        width:20px;
        background-color: #fff;
        border: none;
      }
      .showStructure {
        margin-left: 14px;
      }
      .dataSourceType {
        display: flex;
        margin-left: 137px;
        color: #7D7D7D;
        left: 175px;
        position: absolute;
        top: 390px;
      }
      .form {
        flex-wrap: nowrap;
      }
    }
  }
  .structure-detail {
    display: flex;
    width: 416px;
    height: 450px;
    border: 1px solid #C8D3E9;
    margin-top: 20px;
    margin-left:60px;
    border-radius: 2px;
    flex-wrap: wrap;
    flex-direction: column;
    .detail-title {
      width: 100%;
      height: 44px;
      margin-top: 26px;
      color: #4A4A4A;
      border-bottom: 1px solid #C8D3E9;
      .datasourceFont {
        margin-left: 85px;     
      }
      .schemaFont {
        margin-left: 115px;
      }
    }
    .detail-item {
      display: flex;
      .icon {
        display: inline-block;
        text-align: center;
        height: 40px;
        width: 50px;
        margin-top: 10px;
        margin-left: 7px;
        color: #C8D3E9;
        line-height: 50px;
      }
      .dataSource {
        margin-left: 41px;
        margin-top: 13px;
        width: 130px;
        height: 33px;
        line-height: 33px;
        text-align: center;
        background-color: #EEF5FE;
        border-radius: 2px;
      }
      .Dagdatasource {
        margin-left: 10px;
      }
    }
    
  }
`
const FormItem = Form.Item
const { Option } = Select;

export default function JobStepTwo({ InputDataForm }) {
  let noden = null;

  const [form] = Form.useForm();

  const [choseDag,setChoseDag] = useState(null)

  const [node,setNode] = useState(null)

  const [dagName,setDagName] = useState(null)
  //获取数据源
  //数据源名称
  const [datasourceName,setDatasourceName] = useState()
  const [datasourceNam,setDatasourceNam] = useState()

  //数据源ID
  const [datasourceID,setDatasourceID] = useState()
  const [datasourceI,setDatasourceI] = useState()

  const [detailIsSHow,setDetailIsSHow] = useState('none')

  const getDagInfo = async () => {
    // console.log('----===');
    // console.log(choseDag);    
    // console.log('---===');
    const data = await getDagInfomation('/test.dag')
    // console.log(data);
    if(data.status === 200) {
      noden = data.data.nodes.find(item => item.op === 'datasource')
      // const node = data.data.nodes.find(item => item.op === 'datasource')
      // console.log(noden);
      setNode(noden)
      setDagName(noden.name)
    }
  }

  const getDataSource = async () => {
    const params = {
      page: 1,
      size: 100
    }
    //////
    const data = await getDataSourceInfo(params)
    console.log('------------------------------------------------');
    console.log(data);
    console.log('------------------------------------------------');
    console.log(data.data.data.items[0].id);
    setDatasourceNam(data)
    setDatasourceName(data.data.data.items[0].datasource_name)
    setDatasourceI(data)
    setDatasourceID(data.data.data.items[0].id)
    if(data.data.code === 200){
      getTableName()
    }
  }

  const getTableName = async () => {
    const data = await getTableNameInfo(datasourceID)
     data = await getTableNameInfo(datasourceID)

    console.log(data);
  }
  const showStructure = () => {
    setDetailIsSHow('block')
    console.log(InputDataForm.getFieldValue());
  }
  const tableData =[
    "datax_plugin",
    "grades",
    "grades1",
    "grades2",
    "job_group",
    "job_group_copy1",
    "job_group_copy2",
    "job_info",
    "job_info_copy1",
    "job_jdbc_datasource",
    "job_lock",
    "job_log",
    "job_log_report",
    "job_logglue",
    "job_permission",
    "job_registry",
    "job_template",
    "job_user"
  ]
  useEffect(() => {
    bus.on('DAGSend', data => {
      if (data !== ''){
      }
    })
    const DJName = InputDataForm.getFieldValue('choseTable')
    if (DJName) {
      InputDataForm.setFieldValue('choseTable',DJName)
      console.log()
    }
    getDagInfo()
    getDataSource()
  }, []);
  return (
    <>
      <StepTwo>
      <div className='StepTwo-content'>
        <div className='content-item'>
          <Form name="control-hooks" form={InputDataForm} className="form">
            <FormItem
            name="sort"
            label={dagName}
            className="dtsource"
            >
              <Select
              allowClear
              >
              {/*  */}
                <Option value={datasourceName}>{datasourceName}</Option>
              </Select>
            </FormItem>
            <FormItem
            name='choseTable'
            label="选择表1"
            className='item-choseList'>
              <Select
              allowClear
              >
                {tableData.map((item) => (
                  <Option key={item}>{item}</Option>
                  ))
                }
              </Select>
              <Alert 
              type='success'
              showIcon
              className='stateIcon'
              >
              </Alert>
              <Button 
              type='primary' 
              className='showStructure'
              onClick={showStructure}>
              结构预览</Button>
            </FormItem>
            <div className='dataSourceType'>
              数据源类型:
              <div>
                <span>
                  hive
                </span>
              </div>
            </div>
          </Form>
        </div>
      </div>
      <div className='structure-detail' style={{display: detailIsSHow}}>
        <div className='detail-title'>
          <span className='datasourceFont'>数据源1</span>
          <span className='schemaFont'>Dag输入源结构</span>
        </div>
        <div className='detail-item'> 
          <div className='dataSource'>
            <span>表1字段1.string</span>
          </div>
          <span className='icon'><svg t="1663331186772"  viewBox="0 0 1024 1024" version="1.1" xmlns="http://www.w3.org/2000/svg" p-id="2086" width="20" height="20"><path d="M398.222222 398.222222h170.666667v56.888889H398.222222V398.222222z m-341.333333 170.666667h227.555555v56.888889H56.888889v-56.888889z m910.222222-113.777778h-227.555555V398.222222h227.555555v56.888889zM398.222222 853.333333H341.333333V398.222222h56.888889v455.111111z m540.444445 0H398.222222v-56.888889h512V455.111111h56.888889v398.222222h-28.444444zM85.333333 170.666667H625.777778v56.888889H113.777778v341.333333H56.888889V170.666667h28.444444z m568.888889 455.111111H455.111111v-56.888889h170.666667V170.666667h56.888889v455.111111h-28.444445z" fill="#333333" p-id="2087"></path></svg></span>
          <div className='dataSource Dagdatasource'>
            <span>表1字段1.string</span>
          </div>
        </div>
      </div>
    </StepTwo>
    </>
    
  )
}